﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Target : MonoBehaviour
{
    private Light _light;
    [SerializeField]
    private float _rangeScenario = 3;
    private Time _called;

    private float _nextPositionTime = 0; 
    private void Awake()
    {
        _light = this.GetComponent<Light>();
        SetTarget(false);
    }

    private void OnTriggerEnter(Collider other)
    {
        if (other.CompareTag("mlagent") && _nextPositionTime < Time.time)
        {
            Invoke("MoverPosicionInicial", 4);
            _nextPositionTime = Time.time + 5; 
            
        }
    }

    private void MoverPosicionInicial()
    {
        bool posicionEncontrada = false;
        int intentos = 100;
        Vector3 posicionPotencial = Vector3.zero;

        while (!posicionEncontrada || intentos >= 0)
        {
            intentos--;
            posicionPotencial = new Vector3(
                transform.parent.position.x + UnityEngine.Random.Range(-_rangeScenario, _rangeScenario),
                0.755f,
                transform.parent.position.z + UnityEngine.Random.Range(-_rangeScenario, _rangeScenario));
            //en el caso de que tengamos mas cosas en el escenario checker que no choca
            Collider[] colliders = Physics.OverlapSphere(posicionPotencial, 0.2f);
            if (colliders.Length == 0)
            {
                transform.position = posicionPotencial;
                posicionEncontrada = true;
            }
        }
    }

    public void SetTarget(bool isActive)
    {
         _light.enabled = isActive;
    }

    public bool isLigthActive()
    {
        return _light.enabled;
    }
}
