﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using Unity.MLAgents;
using Unity.MLAgents.Sensors;

public class BadHumanoid : HumanoidML
{
    [SerializeField]
    private HumanoidML _myEnemy;
    private float _EnemyDistance2Target = 0.4f;


    public override void OnEpisodeBegin()
    {
        _rb.velocity = Vector3.zero;
        _rb.angularVelocity = Vector3.zero;

        MoverPosicionInicial();
        _previous = transform.position;
    }

    public override void Update()
    {
        if (_myEnemy != null)
        {
            //Debug.Log(Vector3.Distance(_target.transform.position, _myEnemy.transform.position));
            if (Vector3.Distance(_target.transform.position, _myEnemy.transform.position) > _EnemyDistance2Target)
            {
                DaPremio(0.002f);
            }
            else
            {
                DaPremio(-1);
                Debug.Log("Enemy in target");
            }
            
        }
        base.Update();
    }

    public override void OnActionReceived(float[] vectorAction)
    {
        float lForward = vectorAction[0];
        float lTurn = 0;
        if (vectorAction[1] == 1)
        {
            lTurn = -1;
        }
        else if (vectorAction[1] == 2)
        {
            lTurn = 1;
        }

        _rb.MovePosition(transform.position +
            transform.forward * lForward * _speed * Time.deltaTime);

        transform.Rotate(transform.up * lTurn * _turnSpeed * Time.deltaTime);

    }

    private void OnTriggerStay(Collider other)
    {
        if (true)
        {
            if (other.CompareTag("target"))
            {
                DaPremio(0.5f);
            }
            if (other.CompareTag("borders"))
            {
                DaPremio(-0.05f);
            }
        }
    }

    public override void CollectObservations(VectorSensor sensor)
    {
        //Distancia al target.
        //Float de 1 posicion.
        sensor.AddObservation(
            Vector3.Distance(_target.transform.position, transform.position));
        //Dirección al target.
        //Vector 3 posiciones. 
        sensor.AddObservation(
            (_target.transform.position - transform.position).normalized);

        //Distancia del enemigo al target
        //Float de 1 posicion
        sensor.AddObservation(
            Vector3.Distance(_target.transform.position, _myEnemy.transform.position));
        //Direccion del enemigo al target
        //Vector de 3 posiciones
        sensor.AddObservation(
            (_target.transform.position - _myEnemy.transform.position).normalized);

        //Distancia al enemigo.
        //Float de 1 posicion.
        sensor.AddObservation(
            Vector3.Distance(_myEnemy.transform.position, transform.position));
        //Direccion al enemigo
        //Vector de 3 posiciones
        sensor.AddObservation(
            (_myEnemy.transform.position - transform.position).normalized);

        //Vector del señor, donde mira.
        //Vector de 3 posiciones. 
        sensor.AddObservation(
            transform.forward);

        //Total 15 observaciones. 
    }



}